$regfile = "m8def.dat"
$crystal = 8000000
$baud = 19200
$lib "mcsbyte.lbx"
'--------------------------------------------------------------------------
Config Portb = Output
Config Portd.4 = Output , Portd.5 = Output , Portd.6 = Output , Portd.7 = Output
A Alias Portd.6 : B Alias Portd.5 : C Alias Portb.3 : D Alias Portb.2 : E Alias Portb.1 : F Alias Portb.0 : G Alias Portd.7 : Dp Alias Portb.4       '       
Dig1 Alias Portb.6 : Dig2 Alias Portd.4 : Dig3 Alias Portb.5 : Dig4 Alias Portb.7       '          
'    
Dim X As Byte , Cifri(4) As Integer , Perenoschikobsh_provodov As Byte , Perenoschiksegmentov As Byte       '    
Config Timer0 = Timer , Prescale = 64 : On Timer0 Pulse : Enable Timer0 : Enable Interrupts       '   0        
Dim Ledm As Byte
Dim Data1 As Byte , Data2 As Byte , Crc As Byte , Dataw As Word , T As Single , H As Single
Dim Cb As Byte
Config Watchdog = 2048
X = 0

'------------I2C---------------------
Config Sda = Portc.5
Config Scl = Portc.4
Print
 Print "_____________________________________"

Cifri(1) = 18 : Cifri(2) = 24 : Cifri(3) = 23 : Cifri(4) = 10
Ledm = 255
Wait 2

Do
I2cstart
I2cwbyte &H80                                               ' - SHT21
I2cwbyte &HE3                                               '  T   
Waitms 100                                                  '
I2cstart
I2cwbyte &H81                                               '  
I2crbyte Data1 , Ack                                        '  ,   
I2crbyte Data2 , Ack                                        '  
I2crbyte Crc , Nack                                         '    (   )
I2cstop                                                     ' 

Dataw = Data1
Shift Dataw , Left , 8
Dataw = Dataw + Data2
T = Dataw * 175.72
T = T / 65536
T = T - 46.85

I2cstart
I2cwbyte &H80                                               ' - SHT21
I2cwbyte &HE5                                               '     
Waitms 100                                                  '
I2cstart
I2cwbyte &H81                                               '  
I2crbyte Data1 , Ack                                        '  ,   
I2crbyte Data2 , Ack                                        '  
I2crbyte Crc , Nack                                         '    (   )
I2cstop                                                     ' 

Dataw = Data1
Shift Dataw , Left , 8
Dataw = Dataw + Data2
H = Dataw * 125
H = H / 65536
H = H - 6

'Print "> T " ; T ; " H " ; H
Print "  T " ; Fusing(t , "#.##") ; "   H " ; Fusing(h , "#.#")

Cb = Round(t)
Cifri(2) = Cb Mod 10
Cifri(1) = Cb \ 10
'Cifri(1) = 2
Cb = Round(h)
Cifri(4) = Cb Mod 10
Cifri(3) = Cb \ 10

Wait 1
Loop

Pulse:                                                      '   0
Reset Watchdog
Perenoschikobsh_provodov = &H00
Gosub Perenos
Incr X : If X > 3 Then X = 0                                'X>3
Perenoschiksegmentov = Lookup(cifri(x + 1) , Dta)
Perenoschiksegmentov.7 = Ledm.x
Set Perenoschikobsh_provodov.x
Gosub Perenos
Perenoschiksegmentov = 0
Return

Perenos:
Dig1 = Perenoschikobsh_provodov.0
Dig2 = Perenoschikobsh_provodov.1
Dig3 = Perenoschikobsh_provodov.2
Dig4 = Perenoschikobsh_provodov.3
A = Perenoschiksegmentov.0
B = Perenoschiksegmentov.1
C = Perenoschiksegmentov.2
D = Perenoschiksegmentov.3
E = Perenoschiksegmentov.4
F = Perenoschiksegmentov.5
G = Perenoschiksegmentov.6
Dp = Perenoschiksegmentov.7
'Dp = Ledm.x
Return

       Dta:                                                 '          : 0123456789

       Data &B01000000 , &B01111001 , &B10100100 , &B00110000 , &B00011001 , &B00010010 , &B10000010 , &B11111000 , &B10000000 , &B10010000 ,

       '  H   E   L  " "  -
       '  o      F   o   c
       '  n   d   U   P  C
       ' 10  11  12  13  14
       ' 15  16  17  18  19
       ' 20  21  22  23  24
       Data &B10001001 , &B10000110 , &B11000111 , &B11111111 , &B10111111 ,
       Data &B10100011 , &B11001110 , &B10001110 , &B10011100 , &B10100111 ,
       Data &B10101011 , &B10100001 , &B01000001 , &B10001100 , &B11000110